Package icyllis.modernui.transition

# Class TransitionPropagation

java.lang.Object
icyllis.modernui.transition.TransitionPropagation

Direct Known Subclasses:
  `VisibilityPropagation`

public abstract class TransitionPropagation extends Object
Extend `TransitionPropagation` to customize start delays for Animators created in `Transition.createAnimator(ViewGroup, TransitionValues, TransitionValues)`. A Transition such as `Explode` defaults to using `CircularPropagation` and Views closer to the epicenter will move out of the scene later and into the scene sooner than Views farther from the epicenter, giving the appearance of inertia. With no TransitionPropagation, all Views will react simultaneously to the start of the transition.

See Also:
  - `Transition.setPropagation(TransitionPropagation)`
  - `Transition.getEpicenter()`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `TransitionPropagation()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract void`
  `captureValues(TransitionValues transitionValues)`
  Captures the values in the start or end scene for the properties that this transition propagation monitors.
  `abstract String[]`
  `getPropagationProperties()`
  Returns the set of property names stored in the `TransitionValues` object passed into `captureValues(TransitionValues)` that this transition propagation cares about for the purposes of preventing duplicate capturing of property values.
  `abstract long`
  `getStartDelay(ViewGroup sceneRoot, Transition transition, TransitionValues startValues, TransitionValues endValues)`
  Called by Transition to alter the Animator start delay.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### TransitionPropagation

    public TransitionPropagation()

- ## Method Details

  - ### getStartDelay

    public abstract long getStartDelay(@Nonnull ViewGroup sceneRoot, @Nonnull Transition transition, @Nullable TransitionValues startValues, @Nullable TransitionValues endValues)
    Called by Transition to alter the Animator start delay. All start delays will be adjusted such that the minimum becomes zero.
    Parameters:
      `sceneRoot` - The root of the View hierarchy running the transition.
      `transition` - The transition that created the Animator
      `startValues` - The values for a specific target in the start scene.
      `endValues` - The values for the target in the end scene.
    Returns:
      A start delay to use with the Animator created by `transition`. The delay will be offset by the minimum delay of all `TransitionPropagation`s used in the Transition so that the smallest delay will be 0. Returned values may be negative.

  - ### captureValues

    public abstract void captureValues(@Nonnull TransitionValues transitionValues)
    Captures the values in the start or end scene for the properties that this transition propagation monitors. These values are then passed as the startValues or endValues structure in a later call to `getStartDelay(ViewGroup, Transition, TransitionValues, TransitionValues)`. The main concern for an implementation is what the properties are that the transition cares about and what the values are for all of those properties. The start and end values will be compared later during the `getStartDelay(ViewGroup, Transition, TransitionValues, TransitionValues)`. method to determine the start delay.

    Subclasses must implement this method. The method should only be called by the transition system; it is not intended to be called from external classes.

    Parameters:
      `transitionValues` - The holder for any values that the Transition wishes to store. Values are stored in the `values` field of this TransitionValues object and are keyed from a String value. For example, to store a view's rotation value, a transition might call `transitionValues.values.put("appname:transitionname:rotation", view.getRotation())`. The target view will already be stored in the transitionValues structure when this method is called.

  - ### getPropagationProperties

    @Nullable public abstract String[] getPropagationProperties()
    Returns the set of property names stored in the `TransitionValues` object passed into `captureValues(TransitionValues)` that this transition propagation cares about for the purposes of preventing duplicate capturing of property values.

    A `TransitionPropagation` must override this method to prevent duplicate capturing of values and must contain at least one

    Returns:
      An array of property names as described in the class documentation for `TransitionValues`.